/* 
main_CAN_Hello_World.c
Dieses Programm ist eine einfach Version eine CAN Komunikation einzurichten.
Es empfngt belibige CAN Frames bei 250 KBaud. 
Andert den dritten Datensatz auf 0x22,
Schaltet eine LED ein wenn der erste Datensatz < 0 ist. 
Dazu Schliee eine LED mit (-) an Pin5 von Port C.
Das andere Ende mit 330 Ohm an +5V.

Alle zustzlichen Dateien Lib, include... sind direkt und unverndert von Atmel.
Aunahme config.h, hier bitte Oszylatorfrequenz und Baudrate anpassen. 
Die Datei kommt von dem Atmel Beispiel "can_spy_echo_example". Beachte auch die 
Libary Erklrung AT90CAN128-64-32_CAN Library.pdf in der CAN Libary.

Erstellt mit AVR Studio 4.13 und dem C-Plugin WinAVR-20070525.
Aurel, 24 Mrz 2008
*/


#include <config.h>
#include <can_lib.h>
#include <can_drv.h>

int main (void){


st_cmd_t message_in, message_out;	// Beide Massag Objekte initialisieren
unsigned char data[7], i;			// Datenbereich schaffen
for(i=0;i<8;i++) data[i]=0x77;		// Daten initialisieren


DDRC = (1<<DDC5);				//Pin C5 als Ausgang
PORTC = (1<<PC5);				//LED aus, Ausgang auf high


can_init (CAN_BAUDRATE);		// CAN initialisieren, Bautrate und Ozl. Frequenz in Config.h richtig eingeben!



// Empfangs Massage
message_in.cmd = CMD_RX;		// Message Typ einstellen senden, empfangen, remote...
message_in.pt_data = &data[0];	// Den Zeiger der Message auf den Datenort einstellen



// Sende Massage
message_out.cmd = CMD_TX;		// Message Typ einstellen senden, empfangen, remote...
message_out.id.std = 0x555;		// CAN ID einstellen
message_out.dlc = 8;			// Anzahl der Daten
message_out.pt_data = &data[0];	// Den Zeiger der Message auf den Datenort einstellen
message_out.ctrl.rtr = 0;   	// 0 = Data Frame, 1 = Remote Frame
message_out.ctrl.ide = 0;   	// 0 = Standard Frame, 1 = extended Frame


while(1){

// Empfang
	while(can_cmd(&message_in) != CAN_CMD_ACCEPTED);				// Daten empfangen
	while(can_get_status(&message_in) == CAN_STATUS_NOT_COMPLETED);	// Empfang vollstndig abwarten


	data[2] = 0x22;		// Daten zur Kontrolle verndern
	

// Senden
	while(can_cmd(&message_out) != CAN_CMD_ACCEPTED); 					// Daten senden
	while(can_get_status(&message_out) == CAN_STATUS_NOT_COMPLETED);	// Sendung vollstndig abwarten


	if(data[0] != 0) PORTC = (0<<PC5);				//LED an wenn > 0
	else PORTC = (1<<PC5);							// sonst LED aus


} //end while



return 0;
}//end main

